//GDSIIExporter.cpp
//Copyright  2001-2005 Easy Math Solution. All Rights Reserved
//http://www.e-MathSolution.com
//For details contact us: info@e-MathSolution.com

#include "GDSIIExporter.h"

//Function variables
TGDS_Path           GDS_Path;
TGDS_Boundary		GDS_Boundary;
TGDS_Circle			GDS_Circle;
TGDS_Arc			GDS_Arc;
TGDS_Sector			GDS_Sector;
TGDS_BoxWH			GDS_BoxWH;
TGDS_Box			GDS_Box;
TGDS_Square			GDS_Square;
TGDS_Sref			GDS_Sref;
TGDS_Aref			GDS_Aref;
TGDS_BeginStructure	GDS_BeginStructure;
TGDS_EndStructure	GDS_EndStructure;
TGDS_BeginLib		GDS_BeginLib;
TGDS_EndLib			GDS_EndLib;
TGDS_Text			GDS_Text;
TGDS_Node			GDS_Node;
TSetErrorHandle	    SetErrorHandle;

HINSTANCE hDLL=NULL;


///////////////////////////////////////////////////////////////
//CallBack function for errors handling
#if defined(__BORLANDC__)
void __stdcall ErrorHandler(const TCHAR*err) 
{
        throw GDSIIException(err);
}
#endif


//////////////////////////////////////////////////////////////////////
//Load GDSIIExporter and to get address of the interface functions
bool LoadGDSIIExporter(void)
{
    if((hDLL = LoadLibrary(_T("GDSIIExporter.dll")))==NULL)
            return false;

    GDS_Path		=(TGDS_Path)GetProcAddress(hDLL,_T("GDS_Path"));
	GDS_Boundary	=(TGDS_Boundary)GetProcAddress(hDLL,_T("GDS_Boundary"));
	GDS_Circle		=(TGDS_Circle)GetProcAddress(hDLL,_T("GDS_Circle"));
	GDS_Arc			=(TGDS_Arc)GetProcAddress(hDLL,_T("GDS_Arc"));
	GDS_Sector		=(TGDS_Sector)GetProcAddress(hDLL,_T("GDS_Sector"));
	GDS_BoxWH		=(TGDS_BoxWH)GetProcAddress(hDLL,_T("GDS_BoxWH"));
	GDS_Box			=(TGDS_Box)GetProcAddress(hDLL,_T("GDS_Box"));
	GDS_Square		=(TGDS_Square)GetProcAddress(hDLL,_T("GDS_Square"));
	GDS_Sref		=(TGDS_Sref)GetProcAddress(hDLL,_T("GDS_Sref"));
	GDS_Aref		=(TGDS_Aref)GetProcAddress(hDLL,_T("GDS_Aref"));
	GDS_BeginStructure=(TGDS_BeginStructure)GetProcAddress(hDLL,_T("GDS_BeginStructure"));
	GDS_EndStructure	=(TGDS_EndStructure)GetProcAddress(hDLL,_T("GDS_EndStructure"));
	GDS_BeginLib	=(TGDS_BeginLib)GetProcAddress(hDLL,_T("GDS_BeginLib"));
	GDS_EndLib	=(TGDS_EndLib)GetProcAddress(hDLL,_T("GDS_EndLib"));
	GDS_Text	=(TGDS_Text)GetProcAddress(hDLL,_T("GDS_Text"));
	GDS_Node	=(TGDS_Node)GetProcAddress(hDLL,_T("GDS_Node"));
	SetErrorHandle=(TSetErrorHandle)GetProcAddress(hDLL,_T("SetErrorHandle"));
		
        
        if( !GDS_Path ||  !GDS_Boundary ||   !GDS_Circle ||   !GDS_Arc ||
            !GDS_Sector || !GDS_BoxWH || !GDS_Box || !GDS_Square ||
            !GDS_Sref || !GDS_Aref ||!GDS_BeginStructure || !GDS_EndStructure ||
             !GDS_BeginLib || !GDS_EndLib ||!GDS_Node ||!GDS_Text || 
			 !SetErrorHandle )
            return false;

#if defined(__BORLANDC__)
        SetErrorHandle(ErrorHandler);
#endif

        return true;
}

//////////////////////////////////////////////////////////////////
//
void UnLoadGDSIIExporter(void)
{
	if(hDLL){
		SetErrorHandle(NULL);
        FreeLibrary(hDLL);
	}
}



